// General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
// base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
// The model can simulate OLEDs, Perovskite cells, and OFETs.
// 
// Copyright (C) 2008-2020 Roderick C. I. MacKenzie
// All rights reserved.
// 
// https://www.gpvdm.com
// r.c.i.mackenzie at googlemail.com
// 
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the GPVDM nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include "../lock.h"
#include <mrnd.h>
#include <true_false.h>

void error(const char *msg)
{
    perror(msg);
    exit(1);
}

int main(int argc, char *argv[])
{
char user[40];
//printf("username:");
//fgets(user,20,stdin);
//strcpy(user,"roderick");
//struct safe mysafe;
//lock_gen_key(&mysafe,user);
//lock_encrypt_key(&mysafe,"hello");
//lock_write_key("/home/rod/","li.inp",&mysafe);
//exit(0);

FILE *log;

int i;


char mykey[255];

     int sockfd, newsockfd, portno;
     socklen_t clilen;
     char buffer[500];
     struct sockaddr_in serv_addr, cli_addr;
     int n;
     sockfd = socket(AF_INET, SOCK_STREAM, 0);
     if (sockfd < 0)
        error("ERROR opening socket");


     bzero((char *) &serv_addr, sizeof(serv_addr));
     portno = 1024;
     serv_addr.sin_family = AF_INET;
     serv_addr.sin_addr.s_addr = INADDR_ANY;
     serv_addr.sin_port = htons(portno);
     if (bind(sockfd, (struct sockaddr *) &serv_addr,
              sizeof(serv_addr)) < 0)
              error("ERROR on binding");
do
{
log=fopen("./log.dat","a");
     listen(sockfd,5);
     clilen = sizeof(cli_addr);
     newsockfd = accept(sockfd,
                 (struct sockaddr *) &cli_addr,
                 &clilen);
     if (newsockfd < 0)
          error("ERROR on accept");

//strcpy(user,"roderick");
struct safe mysafe;
//lock_gen_key(&mysafe,user);
//lock_encrypt_key(&mysafe,"hello");
//lock_write_key("/home/rod/","li.inp",&mysafe);
     //bzero(buffer,500);
	n = read(newsockfd,&mysafe,sizeof(struct safe));
	char name[100];
	char tempstring[100];

	if (n < 0) error("n too small");

	if (n>sizeof(struct safe))
	{
		error("n too big");
	     //n = write(newsockfd,"out of bounds",strlen("out of bounds"));
	}
	lock_decrypt_key(&mysafe,lock_to_server);
	lock_print_key(&mysafe);
	strcpy(user,mysafe.user);
	sprintf(name,"%s.inp",user);
	FILE *info=fopen(name,"r");
	if (info==NULL)
	{
		printf("User asked for file %s which does not exist\n",name);
	}else
	{
		int delta=0;
		fscanf(info,"%s",tempstring);
		fscanf(info,"%d",&delta);

		int usemac=0;
		fscanf(info,"%s",tempstring);
		fscanf(info,"%d",&usemac);

		if (usemac==FALSE) strcpy(mysafe.mac,"none");

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.sim_jv));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.sim_tpc));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.sim_ce));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.sim_li));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.sim_tpv));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.sim_voc));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.sim_light_for_voc));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.sim_jv_one_point));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.sim_tof));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.sim_celiv));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.sim_fish));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.fit_enable));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.max_layers));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.auto_disable));

		fscanf(info,"%s",tempstring);
		fscanf(info,"%hhu",&(mysafe.check_web));

		fscanf(info,"%s",tempstring);

		if (strcmp("#end",tempstring)!=0)
		{
			printf("Problem with config file %s %s\n",name,tempstring);
			exit(0);
		}

		fclose(info);

		mysafe.end+=delta;

		lock_print_key(&mysafe);
		sprintf(name,"%s.decrypt",user);
		lock_write_key("./",name,&mysafe);
		lock_encrypt_key(&mysafe,lock_store);
		sprintf(name,"%s.store",user);
		lock_write_key("./",name,&mysafe);
		lock_decrypt_key(&mysafe,lock_store);

		lock_encrypt_key(&mysafe,lock_to_client);



	     n = write(newsockfd,&mysafe,sizeof(struct safe));
	     if (n < 0) error("ERROR writing to socket");
	}


close(newsockfd);
fclose(log);
}while(1);

     return 0;
}
